package org.dive4elements.river.artifacts.model.minfo;

import gnu.trove.TDoubleArrayList;


public class BedDiameterResult
extends BedQualityDiameterResult
{
    protected TDoubleArrayList diameterCap;
    protected TDoubleArrayList diameterSub;

    public BedDiameterResult (
        String type,
        TDoubleArrayList diameterCap,
        TDoubleArrayList diameterSub,
        TDoubleArrayList km
    ) {
        super(type, km);
        this.diameterCap = diameterCap;
        this.diameterSub = diameterSub;
    }

    public double getDiameterCap(int ndx) {
        if (diameterCap != null) {
            return this.diameterCap.get(ndx);
        }
        return Double.NaN;
    }

    public double getDiameterSub(int ndx) {
        if (diameterSub != null) {
            return this.diameterSub.get(ndx);
        }
        return Double.NaN;
    }

    public double getDiameterCap(double km) {
        if (kms.indexOf(km) >= 0) {
            return diameterCap.get(kms.indexOf(km));
        }
        return Double.NaN;
    }

    public double getDiameterSub(double km) {
        if (kms.indexOf(km) >= 0) {
            return diameterSub.get(kms.indexOf(km));
        }
        return Double.NaN;
    }

    public double[][] getDiameterCapData() {
        return new double[][] {
            kms.toNativeArray(),
            diameterCap.toNativeArray()
        };
    }

    public double[][] getDiameterSubData() {
        return new double[][] {
            kms.toNativeArray(),
            diameterSub.toNativeArray()
        };
    }
}
